﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.47
@EndOfDesignText@
'Custom View class
'#Event: ExampleEvent (Value As Int)
'#DesignerProperty: Key: BooleanExample, DisplayName: Boolean Example, FieldType: Boolean, DefaultValue: True, Description: Example of a boolean property.
'#DesignerProperty: Key: IntExample, DisplayName: Int Example, FieldType: Int, DefaultValue: 10, MinRange: 0, MaxRange: 100, Description: Note that MinRange and MaxRange are optional.
'#DesignerProperty: Key: StringWithListExample, DisplayName: String With List, FieldType: String, DefaultValue: Sunday, List: Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday
'#DesignerProperty: Key: StringExample, DisplayName: String Example, FieldType: String, DefaultValue: Text
'#DesignerProperty: Key: ColorExample, DisplayName: Color Example, FieldType: Color, DefaultValue: 0xFFCFDCDC, Description: You can use the built-in color picker to find the color values.
'#DesignerProperty: Key: DefaultColorExample, DisplayName: Default Color Example, FieldType: Color, DefaultValue: Null, Description: Setting the default value to Null means that a nullable field will be displayed.

Sub Class_Globals
	Private fx As JFX
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As Pane
	Private TableView1 As TableView
	Private SBV,SBH As JavaObject
	Private Overlay As Pane
	Private ClipRect As JavaObject
	Private LeftInset As Double = 2
	Private ScrollBarWidth As Double = 20
	Private RowHeight As Double = 30
	Private Padding As Double = 4
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	TableView1.Initialize("TableView1")
	Overlay.Initialize("")
	ClipRect.InitializeNewInstance("javafx.scene.shape.Rectangle",Array(30.0,30.0))
	Dim JO As JavaObject = Overlay
	JO.RunMethod("setClip",Array(ClipRect))
	CSSUtils.SetBackgroundColor(Overlay,fx.Colors.White)
	Overlay.Visible = False
	CallSubDelayed(Me,"SetListeners")
End Sub

Public Sub DesignerCreateView (Base As Pane, Lbl As Label, Props As Map)
	mBase = Base
	mBase.AddNode(TableView1,0,0,mBase.PrefWidth,mBase.PrefHeight)
	mBase.AddNode(Overlay,TableView1.Left + LeftInset ,TableView1.Top + 31, TableView1.PrefWidth - ScrollBarWidth, RowHeight)
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	TableView1.PrefWidth = Width
	TableView1.PrefHeight = Height
	ClipRect.RunMethod("setWidth",Array(Width - ScrollBarWidth))
End Sub

Public Sub GetBase As Pane
	Return mBase
End Sub
Public Sub GetTableView As TableView
	Return TableView1
End Sub


Private Sub SetListeners
	'Get the horizontal and vertical scrollbars attached to the table view so that we can add listeners
	Dim JO As JavaObject = TableView1
	Dim L As JavaObject = JO.RunMethod("lookupAll",Array(".scroll-bar"))
	Dim Iterator As JavaObject = L.RunMethod("iterator",Null)
	Do While Iterator.RunMethod("hasNext",Null)
		Dim SB As JavaObject = Iterator.RunMethod("next",Null)
		If SB.RunMethodJO("getOrientation",Null).RunMethod("toString",Null) = "VERTICAL" Then SBV = SB
		If SB.RunMethodJO("getOrientation",Null).RunMethod("toString",Null) = "HORIZONTAL" Then SBH = SB
	Loop
	Dim O As Object = SBV.CreateEventFromUI("javafx.beans.value.ChangeListener","SBVScroll",Null)
	SBV.RunMethodJO("valueProperty",Null).RunMethod("addListener",Array(O))
	
	O = SBH.CreateEventFromUI("javafx.beans.value.ChangeListener","SBHScroll",Null)
	SBH.RunMethodJO("valueProperty",Null).RunMethod("addListener",Array(O))
	
	'Add a listener to the list items.
	Dim Items As JavaObject = JO.RunMethodJO("getItems",Null)
	O = Items.CreateEventFromUI("javafx.collections.ListChangeListener","TVListChanged",Null)
	Items.RunMethod("addListener",Array(O))
End Sub

Private Sub SBVScroll_Event (MethodName As String, Args() As Object)
	Dim Value As JavaObject = Args(0)
	Dim ScrollValue As Double = Value.RunMethod("getValue",Null)
	If ScrollValue = 0 Then
		If Overlay.Visible Then Overlay.Visible = False
	Else
		Overlay.Visible = True
	End If
End Sub

Private Sub SBHScroll_Event (MethodName As String, Args() As Object)
	Dim Value As JavaObject = Args(0)
	Dim ScrollValue As Double = Value.RunMethod("getValue",Null)
	
	'Move the overlay the opposite amount
	Overlay.Left = -ScrollValue
	
	'Set the clip left to the scroll value
	ClipRect.RunMethod("setX",Array(ScrollValue + LeftInset))
	
End Sub

Private Sub TVListChanged_Event (MethodName As String, Args() As Object)
	SetOverLay
End Sub

Private Sub SetOverLay
	'Create a duplicate of Row 0 in the overlay pane
	Dim Row() As Object = TableView1.Items.Get(0)
	If Row.Length = 0 Then Return
	Overlay.RemoveAllNodes
	Dim Left As Double = 0
	For i = 0 To Row.Length - 1
		Dim L As Label
		L.Initialize("Row1Label")
		L.Text = Row(i)
		L.Tag = i
		
		'Padding around the labels text
		Dim Inset As Double = Padding
		If i = 0 Then Inset = Padding - LeftInset
		Dim Insets As JavaObject
		Insets.InitializeNewInstance("javafx.geometry.Insets",Array(Inset))
		Dim JO As JavaObject = L
		JO.RunMethod("setPadding",Array(Insets))
		
		Overlay.AddNode(L,Left,0,TableView1.GetColumnWidth(i),RowHeight)
		Left = Left + TableView1.GetColumnWidth(i)
	Next
End Sub

Private Sub Row1Label_MouseClicked (EventData As MouseEvent)
	'Scroll to the top of the table and select row 0 (or the relevant cell if SingleCellSelection is enabled)
	TableView1.ScrollTo(0)
	If TableView1.SingleCellSelection Then
		Dim Lbl As Label = Sender
		TableView1.SelectCell(0,Lbl.Tag)
	Else
		TableView1.SelectedRow = 0
	End If
End Sub